unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ComCtrls,

  fphttpclient, opensslsockets;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    CheckBox1: TCheckBox;
    Edit1: TEdit;
    Memo1: TMemo;
    Memo2: TMemo;
    StatusBar1: TStatusBar;
    procedure Button1Click(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  http: tfphttpclient;
begin
  Memo1.Clear;
  Memo2.Clear;

  http := tfphttpclient.Create(nil);
  try
    try
      http.AllowRedirect := checkbox1.Checked;
      Memo1.Lines.Text:= http.Get(Edit1.Text);
      Memo2.Lines := http.ResponseHeaders;
      Statusbar1.Panels[0].Text := 'E: ' + http.ResponseStatusText;
      Statusbar1.Panels[1].Text := 'Code: ' + http.ResponseStatusCode.ToString;
    except
      on E: EHttpClient do
      begin
        Memo2.Lines := http.ResponseHeaders;
        Statusbar1.Panels[0].Text := 'E: ' + E.Message;
        Statusbar1.Panels[1].Text := 'Code: ' + http.ResponseStatusCode.ToString;
      end
      else
        raise;
    end;
  finally
    http.Free;
  end;
end;


end.

